package client.somesystem;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

import javax.ejb.EJB;
import javax.ejb.NoSuchEJBException;

import common.somesystem.services.interfaces.SomeService;

public class Main {
 @EJB
 private static SomeService someService;
 private static BufferedReader keyboard;
 private static String command;
 private static String readString(String prompt) {
  System.out.print(prompt);
  try {
   return keyboard.readLine();
  } catch(IOException e2) {
   System.out.println(
    "probably severe exception \"[ " + e2.getMessage() + " ]\""
    );
   System.exit(1);
  }
  // still here?
  return null;
 }
 private static Integer readInteger(String prompt) {
  while(true) {
   System.out.print(prompt);
   try {
    return new Integer(keyboard.readLine());
   } catch(NumberFormatException e1) {
    System.out.println(e1.getMessage());
    continue;
   } catch(IOException e2) {
    System.out.println(
     "probably severe exception \"[ " + e2.getMessage() + " ]\""
     );
    System.exit(1);
   }
  }
 }
 private static void init() {
  keyboard = new BufferedReader(new InputStreamReader(System.in));
 }
 private static void usage() {
  System.out.println("0) exit");
  System.out.println("1) someService");
 }
 private static void menu() {
  usage();
  try {
   while(true) {
    command = keyboard.readLine();
    if(command.equals("1") || command.equals("someService")) {
     someServiceMenu();
    } else if(command.equals("exit") || command.equals("0")) {
     System.out.println("That's it folks!");
     System.exit(1);
    } else {
     System.out.println("Wrong command");
     usage();
    }
   }
  } catch(IOException e) {
   System.out.println(e.getMessage());
   System.exit(1);
  }
 }
 private static void someServiceUsage() {
  System.out.println(" 0) back");
  System.out.println(" 1) createSomeEntity");
 }
 private static void someServiceMenu() {
  someServiceUsage();
  try {
   while(true) {
    command = keyboard.readLine();
    if(command.equals("1") || command.equals("createSomeEntity")) {
     boolean finished = false;
     while(!finished) {
      String t_f = readString(
       "finished? (t(rue) or f(alse)): "
       );
      if(t_f.equals("true") || t_f.equals("t")) {
       boolean ok = false;
       while(!ok) {
        t_f = readString(
         "more entities? (t(rue) or f(alse)): "
         );
        if(t_f.equals("false") || t_f.equals("f")) {
         System.out.println(
          "INFO: it is impossible to create new entities"
          );
         someService.someServiceRemove();
         ok = true;
         finished = true;
         someServiceUsage();
        } else if(t_f.equals("true") || t_f.equals("t")) {
         someService.initSomeEntity();
         ok = true;
         finished = true;
         someServiceUsage();
        } else {
         continue;
        }
       }
      } else if(t_f.equals("false") || t_f.equals("f")) {
       try {
        someService.addOtherEntity();
        System.out.println("added other entity to someEntity");
       } catch(NoSuchEJBException e3) {
        System.out.println("REMEMBER: it was impossible to create new entities");
        finished = true;
       } finally {
        someServiceUsage();
       }
      } else {
       continue;
      }
     }
    } else if(command.equals("0") || command.equals("back")) {
     menu();
    } else {
     System.out.println("Wrong command");
     someServiceUsage();
    }
   }
  } catch(IOException e) {
   System.out.println(
    "probably severe exception \"[ " + e.getMessage() + " ]\""
    );
   System.exit(1);
  }
 }
 public static void main(String... args) {
  init();
  menu();
 }
}