package server.somesystem.services.implementations;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import static javax.persistence.PersistenceContextType.EXTENDED;

import javax.ejb.Stateful;
import javax.ejb.Remove;

import common.somesystem.services.interfaces.SomeService;
import server.somesystem.entities.SomeEntity;
import server.somesystem.entities.OtherEntity;

@Stateful
public class SomeServiceBean implements SomeService {
 @PersistenceContext(type=EXTENDED)
 private EntityManager entityManager;
 private SomeEntity someEntity;
 private Integer someEntityId;
 public void initSomeEntity() {
  someEntityId = (int) (Math.random()*10000);
  someEntity = new SomeEntity(someEntityId);
  entityManager.persist(someEntity);
 }
 public void addOtherEntity() {
  if(someEntity == null) {
   initSomeEntity();
  }
  // begin rather brute-force fix of EXTENDED bug
  // someEntity = entityManager.find(SomeEntity.class, someEntityId);
  // end   rather brute-force fix of EXTENDED bug
  entityManager.persist(
   new OtherEntity(someEntity, (int) (Math.random()*10000))
   );
 }
 @Remove
 public void someServiceRemove() {
 }
}